Skip to main content

Editable is an input field used for editing a single line of text. It renders as static text and transforms into a text input field when the edit interaction is triggered (click, focus, or double-click).

Loading...

Features

  • Use custom controls for the editable
  • Pressing Enter commits the input value
  • Pressing Esc reverts the value
  • Activate edit mode by double-clicking or focusing on the preview text
  • Auto-resize input to fit content

Installation

Install the editable package:

npm install @zag-js/editable @zag-js/react # or yarn add @zag-js/editable @zag-js/react

Anatomy

Check the editable anatomy and part names.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the editable package:

import * as editable from "@zag-js/editable"

The editable package exports two key functions:

  • machine - Behavior logic for the editable.
  • connect - Maps behavior to JSX props and event handlers.

Pass a unique id to useMachine so generated element ids stay predictable.

Then use the framework integration helpers:

import * as editable from "@zag-js/editable" import { useMachine, normalizeProps } from "@zag-js/react" import { useId } from "react" export default function Editable() { const service = useMachine(editable.machine, { id: useId() }) const api = editable.connect(service, normalizeProps) return ( <div {...api.getRootProps()}> <div {...api.getAreaProps()}> <input {...api.getInputProps()} /> <span {...api.getPreviewProps()} /> </div> </div> ) }

Setting the initial value

Set defaultValue to define the initial value.

const service = useMachine(editable.machine, { defaultValue: "Hello World", })

Controlled value

Use value and onValueChange to control the value externally.

const service = useMachine(editable.machine, { value, onValueChange(details) { setValue(details.value) }, })

Controlled edit state

Use edit and onEditChange to control whether the field is in edit mode.

const service = useMachine(editable.machine, { edit, onEditChange(details) { setEdit(details.edit) }, })

Listening for value changes

Editable supports two ways of listening for value changes:

  • onValueChange: called when value changes.
  • onValueCommit: called when the value is committed.
const service = useMachine(editable.machine, { onValueChange(details) { console.log("Value changed", details.value) }, onValueCommit(details) { console.log("Value submitted", details.value) }, })

Listening for revert events

Use onValueRevert to react when a user cancels editing.

const service = useMachine(editable.machine, { onValueRevert(details) { console.log("Value reverted", details.value) }, })

Using custom controls

In some cases, you might need to use custom controls to toggle the edit and read mode. We use the render prop pattern to provide access to the internal state of the component.

import * as editable from "@zag-js/editable" import { useMachine, normalizeProps } from "@zag-js/react" import { useId } from "react" export default function Editable() { const service = useMachine(editable.machine, { id: useId() }) const api = editable.connect(service, normalizeProps) return ( <div {...api.getRootProps()}> <div {...api.getAreaProps()}> <input {...api.getInputProps()} /> <span {...api.getPreviewProps()} /> </div> <div> {!api.editing && <button {...api.getEditTriggerProps()}>Edit</button>} {api.editing && ( <div> <button {...api.getSubmitTriggerProps()}>Save</button> <button {...api.getCancelTriggerProps()}>Cancel</button> </div> )} </div> </div> ) }

Auto-resizing

Set autoResize to true to auto-grow the editable as content changes.

const service = useMachine(editable.machine, { autoResize: true, })

When using autoresize, the input and preview elements should not have any styles. Use all: unset if needed and pass any styles to the "area" element since it's shared by the input and preview elements.

Setting a maxWidth

It is common to set a max width when auto-resizing.

const service = useMachine(editable.machine, { autoResize: true, maxWidth: "320px", })

When the editable reaches the specified max-width, it'll clip the preview text with an ellipsis.

Editing with double click

The editable supports two modes of activating the "edit" state:

  • when the preview part is focused (with pointer or keyboard).
  • when the preview part is double-clicked.

Set activationMode to "dblclick" to only enter edit mode on double click.

const service = useMachine(editable.machine, { activationMode: "dblclick", })

Customizing submit behavior

Use submitMode to control when edits are committed.

const service = useMachine(editable.machine, { submitMode: "enter", // "enter" | "blur" | "both" | "none" })

Usage with Textarea

Editable supports using a textarea instead of an input field. When a textarea is used, the editable will commit the value on Cmd + Enter or Ctrl + Enter.

Use api.getInputProps() to spread input props to the textarea. You might need to cast the input props to the correct type.

<textarea {...(api.getInputProps() as HTMLTextareaProps<HTMLTextareaElement>)} />

Customizing placeholder text

Set placeholder as a string or per-mode object.

const service = useMachine(editable.machine, { placeholder: { preview: "Click to edit", edit: "Type a value", }, })

Customizing accessibility labels

Use translations to customize control labels.

const service = useMachine(editable.machine, { translations: { edit: "Edit value", submit: "Save", cancel: "Cancel", input: "Editable input", }, })

Submitting with an external form

Set form if the hidden input should submit with a form outside the current DOM subtree.

const service = useMachine(editable.machine, { name: "value", form: "checkout-form", })

Styling guide

Each part includes a data-part attribute you can target in CSS.

Focused state

When the editable is in the focused mode, we set a data-focus attribute on the "area" part.

[data-part="area"][data-focus] { /* CSS for the editable's focus state */ }

Empty state

When the editable's value is empty, we set a data-empty attribute on the "area" part.

[data-part="area"][data-empty] { /* CSS for the editable's focus state */ }

Disabled state

When the editable is disabled, we set a data-disabled attribute on the "area" part.

[data-part="area"][data-disabled] { /* CSS for the editable's focus state */ }

Methods and Properties

Machine Context

The editable machine exposes the following context properties:

  • idsPartial<{ root: string; area: string; label: string; preview: string; input: string; control: string; submitTrigger: string; cancelTrigger: string; editTrigger: string; }>The ids of the elements in the editable. Useful for composition.
  • invalidbooleanWhether the input's value is invalid.
  • namestringThe name attribute of the editable component. Used for form submission.
  • formstringThe associate form of the underlying input.
  • autoResizebooleanWhether the editable should auto-resize to fit the content.
  • activationModeActivationModeThe activation mode for the preview element. - "focus" - Enter edit mode when the preview is focused - "dblclick" - Enter edit mode when the preview is double-clicked - "click" - Enter edit mode when the preview is clicked - "none" - Edit can be triggered programmatically only
  • submitModeSubmitModeThe action that triggers submit in the edit mode: - "enter" - Trigger submit when the enter key is pressed - "blur" - Trigger submit when the editable is blurred - "none" - No action will trigger submit. You need to use the submit button - "both" - Pressing `Enter` and blurring the input will trigger submit
  • selectOnFocusbooleanWhether to select the text in the input when it is focused.
  • editbooleanWhether the editable is in edit mode.
  • defaultEditbooleanWhether the editable is in edit mode by default.
  • onEditChange(details: EditChangeDetails) => voidFunction to call when the edit mode changes.
  • maxLengthnumberThe maximum number of characters allowed in the editable
  • disabledbooleanWhether the editable is disabled.
  • readOnlybooleanWhether the editable is read-only.
  • requiredbooleanWhether the editable is required.
  • placeholderstring | { edit: string; preview: string; }The placeholder text for the editable.
  • translationsIntlTranslationsThe translations for the editable.
  • finalFocusEl() => HTMLElementThe element to receive focus when the editable is closed.
  • valuestringThe controlled value of the editable.
  • defaultValuestringThe initial value of the editable when rendered. Use when you don't need to control the value of the editable.
  • onValueChange(details: ValueChangeDetails) => voidFunction to call when the value changes.
  • onValueRevert(details: ValueChangeDetails) => voidFunction to call when the value is reverted.
  • onValueCommit(details: ValueChangeDetails) => voidFunction to call when the value is committed.
  • dir"ltr" | "rtl"The document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode() => Node | ShadowRoot | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • onPointerDownOutside(event: PointerDownOutsideEvent) => voidFunction called when the pointer is pressed down outside the component
  • onFocusOutside(event: FocusOutsideEvent) => voidFunction called when the focus is moved outside the component
  • onInteractOutside(event: InteractOutsideEvent) => voidFunction called when an interaction happens outside the component

Machine API

The editable api exposes the following methods:

  • editingbooleanWhether the editable is in edit mode
  • emptybooleanWhether the editable value is empty
  • valuestringThe current value of the editable
  • valueTextstringThe current value of the editable, or the placeholder if the value is empty
  • setValue(value: string) => voidFunction to set the value of the editable
  • clearValueVoidFunctionFunction to clear the value of the editable
  • editVoidFunctionFunction to enter edit mode
  • cancelVoidFunctionFunction to exit edit mode, and discard any changes
  • submitVoidFunctionFunction to exit edit mode, and submit any changes

Data Attributes

Area
data-scope
editable
data-part
area
data-focus
Present when focused
data-disabled
Present when disabled
data-placeholder-shown
Present when placeholder is shown
Label
data-scope
editable
data-part
label
data-focus
Present when focused
data-invalid
Present when invalid
data-required
Present when required
Input
data-scope
editable
data-part
input
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
Preview
data-scope
editable
data-part
preview
data-placeholder-shown
Present when placeholder is shown
data-readonly
Present when read-only
data-disabled
Present when disabled
data-invalid
Present when invalid

Accessibility

Keyboard Interactions

  • Enter
    Saves the edited content and exits edit mode.
  • Escape
    Discards the changes and exits edit mode.
Edit this page on GitHub

Skip to main content

Editable is an input field used for editing a single line of text. It renders as static text and transforms into a text input field when the edit interaction is triggered (click, focus, or double-click).

Loading...

Features

  • Use custom controls for the editable
  • Pressing Enter commits the input value
  • Pressing Esc reverts the value
  • Activate edit mode by double-clicking or focusing on the preview text
  • Auto-resize input to fit content

Installation

Install the editable package:

npm install @zag-js/editable @zag-js/svelte # or yarn add @zag-js/editable @zag-js/svelte

Anatomy

Check the editable anatomy and part names.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the editable package:

import * as editable from "@zag-js/editable"

The editable package exports two key functions:

  • machine - Behavior logic for the editable.
  • connect - Maps behavior to JSX props and event handlers.

Pass a unique id to useMachine so generated element ids stay predictable.

Then use the framework integration helpers:

<script lang="ts"> import * as editable from "@zag-js/editable" import { useMachine, normalizeProps } from "@zag-js/svelte" const id = $props.id() const service = useMachine(editable.machine, ({ id })) const api = $derived(editable.connect(service, normalizeProps)) </script> <div {...api.getRootProps()}> <div {...api.getAreaProps()}> <input {...api.getInputProps()} /> <span {...api.getPreviewProps()}>{api.valueText}</span> </div> </div>

Setting the initial value

Set defaultValue to define the initial value.

const service = useMachine(editable.machine, { defaultValue: "Hello World", })

Controlled value

Use value and onValueChange to control the value externally.

const service = useMachine(editable.machine, { value, onValueChange(details) { setValue(details.value) }, })

Controlled edit state

Use edit and onEditChange to control whether the field is in edit mode.

const service = useMachine(editable.machine, { edit, onEditChange(details) { setEdit(details.edit) }, })

Listening for value changes

Editable supports two ways of listening for value changes:

  • onValueChange: called when value changes.
  • onValueCommit: called when the value is committed.
const service = useMachine(editable.machine, { onValueChange(details) { console.log("Value changed", details.value) }, onValueCommit(details) { console.log("Value submitted", details.value) }, })

Listening for revert events

Use onValueRevert to react when a user cancels editing.

const service = useMachine(editable.machine, { onValueRevert(details) { console.log("Value reverted", details.value) }, })

Using custom controls

In some cases, you might need to use custom controls to toggle the edit and read mode. We use the render prop pattern to provide access to the internal state of the component.

<script lang="ts"> import * as editable from "@zag-js/editable" import { useMachine, normalizeProps } from "@zag-js/svelte" const id = $props.id() const service = useMachine(editable.machine, ({ id })) const api = $derived(editable.connect(service, normalizeProps)) </script> <div {...api.getRootProps()}> <div {...api.getAreaProps()}> <input {...api.getInputProps()} /> <span {...api.getPreviewProps()}>{api.valueText}</span> </div> <div> {#if !api.editing} <button {...api.getEditTriggerProps()}>Edit</button> {/if} {#if api.editing} <div> <button {...api.getSubmitTriggerProps()}>Save</button> <button {...api.getCancelTriggerProps()}>Cancel</button> </div> {/if} </div> </div>

Auto-resizing

Set autoResize to true to auto-grow the editable as content changes.

const service = useMachine(editable.machine, { autoResize: true, })

When using autoresize, the input and preview elements should not have any styles. Use all: unset if needed and pass any styles to the "area" element since it's shared by the input and preview elements.

Setting a maxWidth

It is common to set a max width when auto-resizing.

const service = useMachine(editable.machine, { autoResize: true, maxWidth: "320px", })

When the editable reaches the specified max-width, it'll clip the preview text with an ellipsis.

Editing with double click

The editable supports two modes of activating the "edit" state:

  • when the preview part is focused (with pointer or keyboard).
  • when the preview part is double-clicked.

Set activationMode to "dblclick" to only enter edit mode on double click.

const service = useMachine(editable.machine, { activationMode: "dblclick", })

Customizing submit behavior

Use submitMode to control when edits are committed.

const service = useMachine(editable.machine, { submitMode: "enter", // "enter" | "blur" | "both" | "none" })

Usage with Textarea

Editable supports using a textarea instead of an input field. When a textarea is used, the editable will commit the value on Cmd + Enter or Ctrl + Enter.

Use api.getInputProps() to spread input props to the textarea. You might need to cast the input props to the correct type.

<textarea {...(api.getInputProps() as HTMLTextareaProps<HTMLTextareaElement>)} />

Customizing placeholder text

Set placeholder as a string or per-mode object.

const service = useMachine(editable.machine, { placeholder: { preview: "Click to edit", edit: "Type a value", }, })

Customizing accessibility labels

Use translations to customize control labels.

const service = useMachine(editable.machine, { translations: { edit: "Edit value", submit: "Save", cancel: "Cancel", input: "Editable input", }, })

Submitting with an external form

Set form if the hidden input should submit with a form outside the current DOM subtree.

const service = useMachine(editable.machine, { name: "value", form: "checkout-form", })

Styling guide

Each part includes a data-part attribute you can target in CSS.

Focused state

When the editable is in the focused mode, we set a data-focus attribute on the "area" part.

[data-part="area"][data-focus] { /* CSS for the editable's focus state */ }

Empty state

When the editable's value is empty, we set a data-empty attribute on the "area" part.

[data-part="area"][data-empty] { /* CSS for the editable's focus state */ }

Disabled state

When the editable is disabled, we set a data-disabled attribute on the "area" part.

[data-part="area"][data-disabled] { /* CSS for the editable's focus state */ }

Methods and Properties

Machine Context

The editable machine exposes the following context properties:

  • idsPartial<{ root: string; area: string; label: string; preview: string; input: string; control: string; submitTrigger: string; cancelTrigger: string; editTrigger: string; }>The ids of the elements in the editable. Useful for composition.
  • invalidbooleanWhether the input's value is invalid.
  • namestringThe name attribute of the editable component. Used for form submission.
  • formstringThe associate form of the underlying input.
  • autoResizebooleanWhether the editable should auto-resize to fit the content.
  • activationModeActivationModeThe activation mode for the preview element. - "focus" - Enter edit mode when the preview is focused - "dblclick" - Enter edit mode when the preview is double-clicked - "click" - Enter edit mode when the preview is clicked - "none" - Edit can be triggered programmatically only
  • submitModeSubmitModeThe action that triggers submit in the edit mode: - "enter" - Trigger submit when the enter key is pressed - "blur" - Trigger submit when the editable is blurred - "none" - No action will trigger submit. You need to use the submit button - "both" - Pressing `Enter` and blurring the input will trigger submit
  • selectOnFocusbooleanWhether to select the text in the input when it is focused.
  • editbooleanWhether the editable is in edit mode.
  • defaultEditbooleanWhether the editable is in edit mode by default.
  • onEditChange(details: EditChangeDetails) => voidFunction to call when the edit mode changes.
  • maxLengthnumberThe maximum number of characters allowed in the editable
  • disabledbooleanWhether the editable is disabled.
  • readOnlybooleanWhether the editable is read-only.
  • requiredbooleanWhether the editable is required.
  • placeholderstring | { edit: string; preview: string; }The placeholder text for the editable.
  • translationsIntlTranslationsThe translations for the editable.
  • finalFocusEl() => HTMLElementThe element to receive focus when the editable is closed.
  • valuestringThe controlled value of the editable.
  • defaultValuestringThe initial value of the editable when rendered. Use when you don't need to control the value of the editable.
  • onValueChange(details: ValueChangeDetails) => voidFunction to call when the value changes.
  • onValueRevert(details: ValueChangeDetails) => voidFunction to call when the value is reverted.
  • onValueCommit(details: ValueChangeDetails) => voidFunction to call when the value is committed.
  • dir"ltr" | "rtl"The document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode() => Node | ShadowRoot | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • onPointerDownOutside(event: PointerDownOutsideEvent) => voidFunction called when the pointer is pressed down outside the component
  • onFocusOutside(event: FocusOutsideEvent) => voidFunction called when the focus is moved outside the component
  • onInteractOutside(event: InteractOutsideEvent) => voidFunction called when an interaction happens outside the component

Machine API

The editable api exposes the following methods:

  • editingbooleanWhether the editable is in edit mode
  • emptybooleanWhether the editable value is empty
  • valuestringThe current value of the editable
  • valueTextstringThe current value of the editable, or the placeholder if the value is empty
  • setValue(value: string) => voidFunction to set the value of the editable
  • clearValueVoidFunctionFunction to clear the value of the editable
  • editVoidFunctionFunction to enter edit mode
  • cancelVoidFunctionFunction to exit edit mode, and discard any changes
  • submitVoidFunctionFunction to exit edit mode, and submit any changes

Data Attributes

Area
data-scope
editable
data-part
area
data-focus
Present when focused
data-disabled
Present when disabled
data-placeholder-shown
Present when placeholder is shown
Label
data-scope
editable
data-part
label
data-focus
Present when focused
data-invalid
Present when invalid
data-required
Present when required
Input
data-scope
editable
data-part
input
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
Preview
data-scope
editable
data-part
preview
data-placeholder-shown
Present when placeholder is shown
data-readonly
Present when read-only
data-disabled
Present when disabled
data-invalid
Present when invalid

Accessibility

Keyboard Interactions

  • Enter
    Saves the edited content and exits edit mode.
  • Escape
    Discards the changes and exits edit mode.
Edit this page on GitHub

Skip to main content

Editable is an input field used for editing a single line of text. It renders as static text and transforms into a text input field when the edit interaction is triggered (click, focus, or double-click).

Loading...

Features

  • Use custom controls for the editable
  • Pressing Enter commits the input value
  • Pressing Esc reverts the value
  • Activate edit mode by double-clicking or focusing on the preview text
  • Auto-resize input to fit content

Installation

Install the editable package:

npm install @zag-js/editable @zag-js/vue # or yarn add @zag-js/editable @zag-js/vue

Anatomy

Check the editable anatomy and part names.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the editable package:

import * as editable from "@zag-js/editable"

The editable package exports two key functions:

  • machine - Behavior logic for the editable.
  • connect - Maps behavior to JSX props and event handlers.

Pass a unique id to useMachine so generated element ids stay predictable.

Then use the framework integration helpers:

<script setup> import * as editable from "@zag-js/editable" import { normalizeProps, useMachine } from "@zag-js/vue" import { computed } from "vue" const service = useMachine(editable.machine, { id: "1" }) const api = computed(() => editable.connect(service, normalizeProps)) </script> <template> <div ref="ref" v-bind="api.getRootProps()"> <div v-bind="api.getAreaProps()"> <input v-bind="api.getInputProps()" /> <span v-bind="api.getPreviewProps()" /> </div> </div> </template>

Setting the initial value

Set defaultValue to define the initial value.

const service = useMachine(editable.machine, { defaultValue: "Hello World", })

Controlled value

Use value and onValueChange to control the value externally.

const service = useMachine(editable.machine, { value, onValueChange(details) { setValue(details.value) }, })

Controlled edit state

Use edit and onEditChange to control whether the field is in edit mode.

const service = useMachine(editable.machine, { edit, onEditChange(details) { setEdit(details.edit) }, })

Listening for value changes

Editable supports two ways of listening for value changes:

  • onValueChange: called when value changes.
  • onValueCommit: called when the value is committed.
const service = useMachine(editable.machine, { onValueChange(details) { console.log("Value changed", details.value) }, onValueCommit(details) { console.log("Value submitted", details.value) }, })

Listening for revert events

Use onValueRevert to react when a user cancels editing.

const service = useMachine(editable.machine, { onValueRevert(details) { console.log("Value reverted", details.value) }, })

Using custom controls

In some cases, you might need to use custom controls to toggle the edit and read mode. We use the render prop pattern to provide access to the internal state of the component.

<script setup> import * as editable from "@zag-js/editable" import { normalizeProps, useMachine } from "@zag-js/vue" import { computed } from "vue" const service = useMachine(editable.machine, { id: "1" }) const api = computed(() => editable.connect(service, normalizeProps)) </script> <template> <div ref="ref" v-bind="api.getRootProps()"> <div v-bind="api.getAreaProps()"> <input v-bind="api.getInputProps()" /> <span v-bind="api.getPreviewProps()" /> </div> <div> <div v-if="api.editing"> <button v-bind="api.getSubmitTriggerProps()">Save</button> <button v-bind="api.getCancelTriggerProps()">Cancel</button> </div> <button v-else v-bind="api.getEditTriggerProps()">Edit</button> </div> </div> </template>

Auto-resizing

Set autoResize to true to auto-grow the editable as content changes.

const service = useMachine(editable.machine, { autoResize: true, })

When using autoresize, the input and preview elements should not have any styles. Use all: unset if needed and pass any styles to the "area" element since it's shared by the input and preview elements.

Setting a maxWidth

It is common to set a max width when auto-resizing.

const service = useMachine(editable.machine, { autoResize: true, maxWidth: "320px", })

When the editable reaches the specified max-width, it'll clip the preview text with an ellipsis.

Editing with double click

The editable supports two modes of activating the "edit" state:

  • when the preview part is focused (with pointer or keyboard).
  • when the preview part is double-clicked.

Set activationMode to "dblclick" to only enter edit mode on double click.

const service = useMachine(editable.machine, { activationMode: "dblclick", })

Customizing submit behavior

Use submitMode to control when edits are committed.

const service = useMachine(editable.machine, { submitMode: "enter", // "enter" | "blur" | "both" | "none" })

Usage with Textarea

Editable supports using a textarea instead of an input field. When a textarea is used, the editable will commit the value on Cmd + Enter or Ctrl + Enter.

Use api.getInputProps() to spread input props to the textarea. You might need to cast the input props to the correct type.

<textarea {...(api.getInputProps() as HTMLTextareaProps<HTMLTextareaElement>)} />

Customizing placeholder text

Set placeholder as a string or per-mode object.

const service = useMachine(editable.machine, { placeholder: { preview: "Click to edit", edit: "Type a value", }, })

Customizing accessibility labels

Use translations to customize control labels.

const service = useMachine(editable.machine, { translations: { edit: "Edit value", submit: "Save", cancel: "Cancel", input: "Editable input", }, })

Submitting with an external form

Set form if the hidden input should submit with a form outside the current DOM subtree.

const service = useMachine(editable.machine, { name: "value", form: "checkout-form", })

Styling guide

Each part includes a data-part attribute you can target in CSS.

Focused state

When the editable is in the focused mode, we set a data-focus attribute on the "area" part.

[data-part="area"][data-focus] { /* CSS for the editable's focus state */ }

Empty state

When the editable's value is empty, we set a data-empty attribute on the "area" part.

[data-part="area"][data-empty] { /* CSS for the editable's focus state */ }

Disabled state

When the editable is disabled, we set a data-disabled attribute on the "area" part.

[data-part="area"][data-disabled] { /* CSS for the editable's focus state */ }

Methods and Properties

Machine Context

The editable machine exposes the following context properties:

  • idsPartial<{ root: string; area: string; label: string; preview: string; input: string; control: string; submitTrigger: string; cancelTrigger: string; editTrigger: string; }>The ids of the elements in the editable. Useful for composition.
  • invalidbooleanWhether the input's value is invalid.
  • namestringThe name attribute of the editable component. Used for form submission.
  • formstringThe associate form of the underlying input.
  • autoResizebooleanWhether the editable should auto-resize to fit the content.
  • activationModeActivationModeThe activation mode for the preview element. - "focus" - Enter edit mode when the preview is focused - "dblclick" - Enter edit mode when the preview is double-clicked - "click" - Enter edit mode when the preview is clicked - "none" - Edit can be triggered programmatically only
  • submitModeSubmitModeThe action that triggers submit in the edit mode: - "enter" - Trigger submit when the enter key is pressed - "blur" - Trigger submit when the editable is blurred - "none" - No action will trigger submit. You need to use the submit button - "both" - Pressing `Enter` and blurring the input will trigger submit
  • selectOnFocusbooleanWhether to select the text in the input when it is focused.
  • editbooleanWhether the editable is in edit mode.
  • defaultEditbooleanWhether the editable is in edit mode by default.
  • onEditChange(details: EditChangeDetails) => voidFunction to call when the edit mode changes.
  • maxLengthnumberThe maximum number of characters allowed in the editable
  • disabledbooleanWhether the editable is disabled.
  • readOnlybooleanWhether the editable is read-only.
  • requiredbooleanWhether the editable is required.
  • placeholderstring | { edit: string; preview: string; }The placeholder text for the editable.
  • translationsIntlTranslationsThe translations for the editable.
  • finalFocusEl() => HTMLElementThe element to receive focus when the editable is closed.
  • valuestringThe controlled value of the editable.
  • defaultValuestringThe initial value of the editable when rendered. Use when you don't need to control the value of the editable.
  • onValueChange(details: ValueChangeDetails) => voidFunction to call when the value changes.
  • onValueRevert(details: ValueChangeDetails) => voidFunction to call when the value is reverted.
  • onValueCommit(details: ValueChangeDetails) => voidFunction to call when the value is committed.
  • dir"ltr" | "rtl"The document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode() => Node | ShadowRoot | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • onPointerDownOutside(event: PointerDownOutsideEvent) => voidFunction called when the pointer is pressed down outside the component
  • onFocusOutside(event: FocusOutsideEvent) => voidFunction called when the focus is moved outside the component
  • onInteractOutside(event: InteractOutsideEvent) => voidFunction called when an interaction happens outside the component

Machine API

The editable api exposes the following methods:

  • editingbooleanWhether the editable is in edit mode
  • emptybooleanWhether the editable value is empty
  • valuestringThe current value of the editable
  • valueTextstringThe current value of the editable, or the placeholder if the value is empty
  • setValue(value: string) => voidFunction to set the value of the editable
  • clearValueVoidFunctionFunction to clear the value of the editable
  • editVoidFunctionFunction to enter edit mode
  • cancelVoidFunctionFunction to exit edit mode, and discard any changes
  • submitVoidFunctionFunction to exit edit mode, and submit any changes

Data Attributes

Area
data-scope
editable
data-part
area
data-focus
Present when focused
data-disabled
Present when disabled
data-placeholder-shown
Present when placeholder is shown
Label
data-scope
editable
data-part
label
data-focus
Present when focused
data-invalid
Present when invalid
data-required
Present when required
Input
data-scope
editable
data-part
input
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
Preview
data-scope
editable
data-part
preview
data-placeholder-shown
Present when placeholder is shown
data-readonly
Present when read-only
data-disabled
Present when disabled
data-invalid
Present when invalid

Accessibility

Keyboard Interactions

  • Enter
    Saves the edited content and exits edit mode.
  • Escape
    Discards the changes and exits edit mode.
Edit this page on GitHub